package party._2a03.mc.command;

import com.mojang.brigadier.CommandDispatcher;
import net.minecraft.entity.player.PlayerAbilities;
import net.minecraft.server.command.CommandManager;
import net.minecraft.server.command.ServerCommandSource;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;
import party._2a03.mc.util.Config;

public class FlyCommand {
	public static void register(CommandDispatcher<ServerCommandSource> dispatcher) {
		dispatcher.register(CommandManager.literal("fly").executes(ctx -> {
			ServerCommandSource source = ctx.getSource();
			if (Config.getBool("disableFlyCommand")) {
				source.sendFeedback(() -> Text.of("The /fly command is disabled"), true);
				return 0;
			}
			ServerPlayerEntity sender = source.getPlayer();
			PlayerAbilities abilities = sender.getAbilities();
			boolean flight = abilities.allowFlying;
			abilities.allowFlying = !flight;
			if (!flight)
				source.sendFeedback(() -> Text.of("I wanna fly like an eagle... to the sea!"), true);
			else {
				source.sendFeedback(() -> Text.of("Flight disabled"), true);
				abilities.flying = false;
			}
			sender.sendAbilitiesUpdate();
			return 1;
		}));
	}
}
