package party._2a03.mc.command;

import com.mojang.brigadier.CommandDispatcher;
import com.mojang.brigadier.arguments.StringArgumentType;
import com.mojang.brigadier.builder.LiteralArgumentBuilder;
import net.minecraft.server.command.CommandManager;
import net.minecraft.server.command.ServerCommandSource;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.text.Text;
import party._2a03.mc.util.Database;
import party._2a03.mc.util.PlayerData;

import java.util.UUID;

public class NameCommand {
	public static void register(CommandDispatcher<ServerCommandSource> dispatcher) {
		dispatcher.register(CommandManager.literal("name")
		.then(CommandManager.literal("assign")
		.requires(ctx -> { return ctx.hasPermissionLevel(2); })
		.then(CommandManager.argument("UUID", StringArgumentType.word())
		.then(CommandManager.argument("name", StringArgumentType.word())
		.executes(ctx -> {
			UUID uuid = UUID.fromString(StringArgumentType.getString(ctx, "UUID"));
			ServerCommandSource source = ctx.getSource();
			ServerPlayerEntity sender = source.getPlayer();
			PlayerData playerdata = Database.getPlayer(uuid);
			playerdata.setName(StringArgumentType.getString(ctx, "name"));
			source.sendFeedback(() -> Text.of("User's name has been updated (" + uuid.toString() + ")"), true);
			return 1;
		})))));
	}
}
